﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using ClientAppViaWebService.EducationalDivisionsLogicSeviceRef;

namespace ClientAppViaWebService.Forms
{
    public partial class EducationalDivisionEditForm : DivisionEditForm
    {
        EducationalDivisionsLogicSevice lService;
        private readonly Int32 ClassID = 5;

        public EducationalDivisionEditForm()
        {
            InitializeComponent();
            lService = new EducationalDivisionsLogicSevice();
            classTextBox.Text = ClassID.ToString();
        }

        protected override void SetFormProperties(Object _object)
        {
            EducationalDivision d = (_object as EducationalDivision);
            ID = d.ID;
            EXT_ID = d.EXT_ID;
            ParentId = d.PARENT_ID;
            Class = d.CLASS_ID;
            ObjName = d.NAME;
            BossName = d.BOSS_ID;
            DateCreated = d.DATE_CREATED;
            Description = d.DESCRIPTION;
        }

        protected override Object RetrieveFormProperties()
        {
            EducationalDivision division = new EducationalDivision();
            division.ID = ID;
            division.EXT_ID = EXT_ID;
            division.PARENT_ID = ParentId;
            division.CLASS_ID = Class;
            division.NAME = ObjName;
            division.DataBaseName = DataBaseName;
            division.BOSS_ID = BossName;
            division.DATE_CREATED = DateCreated;
            division.DESCRIPTION = Description;
            return division;
        }

        protected override void LoadEditFormData(int parentNodeID)
        {
            EducationalDivision p = lService.SelectEducationalDivision_By_DataBase_And_Id(DataBaseName, parentNodeID);
            SetFormProperties(p);
        }

        protected override void UpdateEntity()
        {
            EducationalDivision obj = RetrieveFormProperties() as EducationalDivision;
            lService.UpdateEducationalDivision(obj);
        }

        protected override void InsertEntity()
        {
            EducationalDivision obj = RetrieveFormProperties() as EducationalDivision;
            lService.InsertEducationalDivision(obj);
        }
    }
}
