﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ClientAppViaWebService.SectionLogicServiceRef;

namespace ClientAppViaWebService.Forms
{
    public partial class SectionEditForm  : OrganizationalDivisionEditForm
    {
        private readonly Int32 ClassID = 13;
        private SectionLogicService sectionService;

        #region Properties.

        public string Location
        {
            get { return txtLocation.Text; }
            set { txtLocation.Text = value; }
        }

        public String Room
        {
            get { return txtRoom.Text; }
            set { txtRoom.Text = value; }
        } 

        public String Schedule
        {
            get { return txtShedule.Text; }
            set { txtShedule.Text = value; }
        }       

        #endregion

        public SectionEditForm()
        {
            InitializeComponent();
            sectionService = new SectionLogicService();
        }

        protected override void SetFormProperties(Object _object)
        {
            Section obj = (_object as Section);
            ID = obj.ID;
            EXT_ID = obj.EXT_ID;
            ParentId = obj.PARENT_ID;
            Class = obj.CLASS_ID;
            ObjName = obj.NAME;
            BossName = obj.BOSS_ID;
            DateCreated = obj.DATE_CREATED;
            Description = obj.DESCRIPTION;
            Location  = obj.LOCATION_ID;
            Email = obj.EMAIL;
            Slogan = obj.SLOGAN;
            Room= obj.ROOM_ID;
            Schedule= obj.SCHEDULE;
        }

        protected override Object RetrieveFormProperties()
        {
            Section obj = new Section();
            obj.ID = ID;
            obj.EXT_ID = EXT_ID;
            obj.PARENT_ID = ParentId;
            obj.CLASS_ID = ClassID;
            obj.NAME = ObjName;
            obj.DataBaseName = DataBaseName;
            obj.BOSS_ID = BossName;
            obj.DATE_CREATED = DateCreated;
            obj.DESCRIPTION = Description;
            obj.LOCATION_ID = Location;
            obj.EMAIL = Email;
            obj.SLOGAN = Slogan;
            obj.ROOM_ID = Room;
            obj.SCHEDULE = Schedule;
            return obj;
        }

        protected override void LoadEditFormData(int parentNodeID)
        {
            Section p = sectionService.SelectSection_By_DataBase_And_Id(DataBaseName, parentNodeID);
            SetFormProperties(p);
        }

        protected override void UpdateEntity()
        {
            Section obj = RetrieveFormProperties() as Section;
            sectionService.UpdateSection(obj);
        }

        protected override void InsertEntity()
        {   
            Section obj = RetrieveFormProperties() as Section;
            sectionService.InsertSection(obj);
        }
    }
}
