﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using ClientAppViaWebService.ServiceDivisionLogicServiceRef;

namespace ClientAppViaWebService.Forms
{
    public partial class ServiceDivisionEditForm : DivisionEditForm
    {
        private readonly Int32 ClassID = 15;
        private ServiceDivisionLogicService serviceDivService;

        #region Properties.

        public string Room
        {
            get { return txtRoom.Text; }
            set { txtRoom.Text = value; }
        }

        public string Telephone
        {
            get { return txtTelephone.Text; }
            set { txtTelephone.Text = value; }
        }       

        #endregion

        public ServiceDivisionEditForm()
        {
            InitializeComponent();
            serviceDivService = new ServiceDivisionLogicService();
        }

        protected override void SetFormProperties(Object _object)
        {  
            ServiceDivision obj = (_object as ServiceDivision);
            ID = obj.ID;
            EXT_ID = obj.EXT_ID;
            ParentId = obj.PARENT_ID;
            Class = obj.CLASS_ID;
            ObjName = obj.NAME;
            BossName = obj.BOSS_ID;
            DateCreated = obj.DATE_CREATED;
            Description = obj.DESCRIPTION;
            Room  = obj.ROOM_ID;
            Telephone= obj.TELEPHONE;
        }

        protected override Object RetrieveFormProperties()
        {
           ServiceDivision obj = new ServiceDivision();
            obj.ID = ID;
            obj.EXT_ID = EXT_ID;
            obj.PARENT_ID = ParentId;
            obj.CLASS_ID = ClassID;
            obj.NAME = ObjName;
            obj.DataBaseName = DataBaseName;
            obj.BOSS_ID = BossName;
            obj.DATE_CREATED = DateCreated;
            obj.DESCRIPTION = Description;
            obj.ROOM_ID = Room;
            obj.TELEPHONE = Telephone;
            return obj;
        }

        protected override void LoadEditFormData(int parentNodeID)
        {
            ServiceDivision p = serviceDivService.SelectServiceDivision_By_DataBase_And_Id(DataBaseName, parentNodeID);
            SetFormProperties(p);
        }

        protected override void UpdateEntity()
        {
            ServiceDivision obj = RetrieveFormProperties() as ServiceDivision;
            serviceDivService.UpdateServiceDivision(obj);
        }

        protected override void InsertEntity()
        {
           ServiceDivision obj = RetrieveFormProperties() as ServiceDivision;
           serviceDivService.InsertServiceDivision(obj);
        }
    }
}
