﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using UniversalDataAccess.BusinessEntities;
using UniversalDataAccess;
using System.Configuration;

namespace WebApplication1
{
    /// <summary>
    /// Summary description for BuildingsLogicService
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    // [System.Web.Script.Services.ScriptService]
    public class BuildingsLogicService : System.Web.Services.WebService
    {

        [WebMethod]
        public string HelloWorld()
        {
            return "Hello World";
        }

        #region Select / Insert / Update /Delete Division.

        [WebMethod]
        public Building SelectBuilding_By_DataBase_And_Id(string databaseName, int id)
        {
            try
            {
                BuildingDataAccess dataAccess = null;


                dataAccess = new BuildingDataAccess(databaseName, ConfigurationManager.ConnectionStrings[databaseName].ConnectionString, false);
                return dataAccess.SelectBuildingBy_Id(id);
            }
            catch (Exception ex)
            {
                throw;
            }
        }

        [WebMethod]
        public List<Building> SelectBuildingListByDataBaseName(string dataBaseName)
        {
            try
            {
                BuildingDataAccess e = new BuildingDataAccess(dataBaseName, ConfigurationManager.ConnectionStrings[dataBaseName].ConnectionString, false);

                return e.SelectBuildingsList();
            }
            catch (Exception ex)
            {
                throw;
            }
        }

        [WebMethod]
        public void InsertBuilding(Building building)
        {
            try
            {
                BuildingDataAccess e = new BuildingDataAccess(building.DataBaseName,
                    ConfigurationManager.ConnectionStrings[building.DataBaseName].ConnectionString, false);

                int new_Id = -1;
                e.InsertBuilding(building, ref new_Id);
            }
            catch (Exception ex)
            {
                throw;
            }
        }

        [WebMethod]
        public void UpdateBuilding(Building building)
        {
            try
            {
                BuildingDataAccess e = new BuildingDataAccess(building.DataBaseName,
                    ConfigurationManager.ConnectionStrings[building.DataBaseName].ConnectionString, false);

                e.UpdateBuilding(building);
            }
            catch (Exception ex)
            {
                throw;
            }
        }

        [WebMethod]
        public void DeleteBuilding(Building building)
        {
            try
            {
                BuildingDataAccess e = new BuildingDataAccess(building.DataBaseName,
                    ConfigurationManager.ConnectionStrings[building.DataBaseName].ConnectionString, false);

                e.DeleteBuilding(building);
            }
            catch (Exception ex)
            {
                throw;
            }
        }

        #endregion              

    }
}
