﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using UniversalDataAccess;
using System.Configuration;
using UniversalDataAccess.BusinessEntities;

namespace WebApplication1
{
    /// <summary>
    /// Summary description for SectionLogicService
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [System.ComponentModel.ToolboxItem(false)]
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    // [System.Web.Script.Services.ScriptService]
    public class SectionLogicService : System.Web.Services.WebService
    {

        [WebMethod]
        public string HelloWorld()
        {
            return "Hello World";
        }
        #region Select / Insert / Update /Delete Section.

        [WebMethod]
        public Section SelectSection_By_DataBase_And_Id(string databaseName, int id)
        {
            try
            {
                SectionDataAccess dataAccess = null;

                dataAccess = new SectionDataAccess(databaseName, ConfigurationManager.ConnectionStrings[databaseName].ConnectionString, false);
                return dataAccess.SelectSectionBy_Id(id);
            }
            catch (Exception ex)
            {
                throw;
            }
        }

        [WebMethod]
        public List<Section> SelectSectionListByDataBaseName(string dataBaseName)
        {
            try
            {
                SectionDataAccess e = new SectionDataAccess(dataBaseName, ConfigurationManager.ConnectionStrings[dataBaseName].ConnectionString, false);

                return e.SelectSectionsList();
            }
            catch (Exception ex)
            {
                throw;
            }
        }

        [WebMethod]
        public void InsertSection(Section division)
        {
            try
            {
                SectionDataAccess e = new SectionDataAccess(division.DataBaseName,
                    ConfigurationManager.ConnectionStrings[division.DataBaseName].ConnectionString, false);

                int new_Id = -1;
                e.InsertSection(division, ref new_Id);
            }
            catch (Exception ex)
            {
                throw;
            }
        }

        [WebMethod]
        public void UpdateSection(Section division)
        {
            try
            {
                SectionDataAccess e = new SectionDataAccess(division.DataBaseName,
                    ConfigurationManager.ConnectionStrings[division.DataBaseName].ConnectionString, false);

                e.UpdateSection(division);
            }
            catch (Exception ex)
            {
                throw;
            }
        }

        [WebMethod]
        public void DeleteSection(Section division)
        {
            try
            {
                SectionDataAccess e = new SectionDataAccess(division.DataBaseName,
                    ConfigurationManager.ConnectionStrings[division.DataBaseName].ConnectionString, false);

                e.DeleteSection(division);
            }
            catch (Exception ex)
            {
                throw;
            }
        }

        #endregion   
    }
}
